program define estprt
* print table of output from estimates in comma-delimited format
* by Christopher Ferrall, Summer 1997
  version 5.0
  loc cnt 1
  loc varlist "opt"
  loc options "Aux(string) Tag(string) Eqlst(string) Rlst(string) Level(real .95)"
  parse "`*'"
  loc j 1
  loc eqj : word `j' of `eqlst'
  di "Tag,Row,Variable,RowType" _cont
  while "`eqj'"!="" {
        di ",`eqj',Sig" _cont
        loc j = `j' + 1
        loc eqj : word `j' of `eqlst'
        }
  di 
  parse "`varlist'", p(" ")
  while ("`1'" != "")  {
        mkstr "`1'" "`tag'" "`eqlst'" `cnt' "`level'"
        loc cnt = `cnt' + 2
        macro shift
        }
  parse "`aux'", p(" ")
  while ("`1'" != "")  {
        mkstr "`1'" "`tag'" "`eqlst'" `cnt' "`level'"
        loc cnt = `cnt' + 2
        macro shift
        }
  loc i 1
  loc rsi : word `i' of `rlst'
  while "`rsi'" != "" {
        loc nm  "res(`rsi')"
        loc bstr "2"
        loc j 1
        loc eqj : word `j' of `eqlst'
        while "`eqj'"!="" {
              eq unhold `eqj'
              loc m = substr("Z`eqj'",1,8)
              capture loc vb = round(`m'[1,`rsi'],.01)
              if _rc > 0 {
                 loc vb = -999
                 }
              loc bstr "`bstr',`vb', "
              eq hold `eqj'
              loc j = `j' + 1
              loc eqj : word `j' of `eqlst'
        }
        loc cnt = `cnt' + 1
        di "`tag',`cnt',`nm',`bstr'"
        loc i = `i' + 1
        loc rsi : word `i' of `rlst'
        }
end

program define mkstr
   tempname b s
   loc nm "`1'"
   loc tag  "`2'"
   loc eqlst  "`3'"
   loc cnt  "`4'"
   loc crit "`5'"
   loc cnt1 = `cnt' + 1
   loc bstr "0"
   loc sstr "1"
   loc j 1
   loc eqj : word `j' of `eqlst'
   while "`eqj'"!="" {
         est unhold `eqj'
         mat `b' = get(_b)
         cap mat `b'  = `b'[1,"`nm'"]
         if _rc == 0 {
            mat `s' = get(VCE)
            mat `s' = vecdiag(`s')
            mat `s' = `s'[1,"`nm'"]
            loc vb = round(`b'[1,1],.00001)
*            loc vb = substr("`vb'",1,10)
            loc vs = round(-sqrt(`s'[1,1]),.0001)
*            loc vs = substr("`vs'",1,10)
            loc m = substr("Z`eqj'",1,8)
            capture loc df = `m'[1,5]
            if _rc > 0 {
               loc df "."
               }
            if  abs(`vb'/max(-`vs',1E-4)) > invt(`df',`crit') {
               loc vt "*"
               }
            else {
               loc vt " "
               }
            }
         else {
              loc vb " "
              loc vs " "
              loc vt " "             
              }
         loc bstr "`bstr',`vb',`vt'"
         loc sstr "`sstr',`vs', "
         est hold `eqj'
         loc j = `j' + 1
         loc eqj : word `j' of `eqlst'
        }
   di "`tag',`cnt',`nm',`bstr'"
   di "`tag',`cnt1', ,`sstr'"
end
